routes/web.php
<?php

use App\Http\Controllers\CommentController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\VotesController;
use App\Models\Category;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ContactController;
use App\Http\Controllers\PostController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');


Route::middleware('auth')->group(function () {

    Route::get('/home', function () {
        return view('home');
    })->name('home');

    Route::get('/about-us', function () {
        return view('about');
    })->name('about-us');

    //Contacts
    Route::get('/contact-us', function () {
        return view('contacts');
    })->name('contact-us');


//Posts
    Route::post('/contact-us', [ContactController::class, 'store'])->name('contact.us.store');

    Route::get('/blog-page', [PostController::class, 'index'])->name('blog-page');

    Route::resource('/posts', PostController::class);

    //Categories
    Route::get('/categories/{category:slug}', function (Category $category) {
        return view('categories.index', ['category' => $category]);
    });

    //Votes
    Route::post('/votes/{post}/like', [VotesController::class, 'likes'])->name('likes');
    Route::post('/votes/{post}/dislike', [VotesController::class, 'dislikes'])->name('dislikes');

    //Comments
    Route::get('/comment/index/{slug}', [CommentController::class, 'index'])->name('comment.index');
    Route::post('/comment/store', [CommentController::class, 'store'])->name('comment.add');


    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__ . '/auth.php';

app/Models/Comment.php
<?php

namespace App\Models;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Comment extends Model
{
    use SoftDeletes;
     use HasFactory;
    protected $dates = ['deleted_at'];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['user_id', 'post_id', 'content'];

    /**
     * The belongs to Relationship
     *
     * @var array
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    /**
     * The has Many Relationship
     *
     * @var array
     */
    public function post()
    {
        return $this->belongsTo(Post::class);
    }
}

app/Http/Controllers/CommentController.php
<?php

namespace App\Http\Controllers;

use App\Models\Comment;
use App\Models\Post;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Redirect;
use Illuminate\View\View;


class CommentController extends Controller
{
    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     */

    public function index($id): View

    {
        $posts = Post::with(['comments'])->where('id', $id)->get();

        $post = [];
        foreach ($posts as $array) {
            $post = $array;
        }


        return view('comments.index', compact('post'));

    }

    public function store(Request $request): RedirectResponse
    {
        $comment = new Comment;
        $comment->content = $request->get('comment_body');
        $comment->user()->associate($request->user());
        $post = Post::find($request->get('post_id'));
        $post->comments()->save($comment);

        return Redirect::back()->with('status', 'profile-updated');


    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

resources/views/comments/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="text-xl font-semibold leading-tight text-gray-800">
            {{ __('Blog Comments') }}
        </h2>
        <meta charset="utf-8"/>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <link rel="stylesheet" href="{{ URL::asset('css/style.css') }}">
        {{--    <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">--}}
        <meta name="viewport" content="width=device-width, initial-scale=1">
    </x-slot>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-body">
                        <hr/>
                        <h4>Current Comments</h4>
                        @if($post->comments->count() > 0)
                            @foreach($post->comments as $comments)
                                <br class="display-comment">
                                <p class="text-comment">"{{ $comments->content }}"</p>
                                <hr/>
                                <p>By {{ $comments->user->name }} on </p>
                                <p class="text-danger ">
                                    {{  date("d M Y", strtotime($comments->created_at)) }}
                                </p>

                    </div>
                    @endforeach
                    @endif
                    @if(empty($post->comments->count()))
                        <p class="text-danger">No comments left. Leave first comment now?</p>
                        <hr/>
                        <form method="post" action="{{ route('comment.add') }}">

                            @csrf

                            <div class="form-group">
                                <input type="text" name="comment_body" class="form-control"/>
                                <input type="hidden" name="post_id" value="{{ $post->id }}"/>
                            </div>


                            <button
                                class="bg-white  hover:bg-red-500 text-gray-800 text-tahiti mt-3 py-1 px-4 border border-gray-400 rounded shadow">
                                {{ __('Send') }}
                            </button>
                            <button
                                class="bg-white hover:bg-[#1da1f2] text-tahiti mt-3 py-1  px-4 border border-gray-400 rounded shadow">
                                <a href="{{ route('posts.index') }}" class="btn btn-default">Back</a>
                            </button>

                        </form>

                    @endif

                    @if (Session::has('success'))
                        <div class="alert alert-success alert-dismissible" role="alert">
                            <button type="button" class="close" data-dismiss="alert">
                                <i class="fa fa-times"></i>
                            </button>
                            <strong>Success !</strong> {{ session('success') }}
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
    </div>
</x-app-layout>